<?php
/**
* @package Easygb
* @copyright (C) 2008. Joomla-addons
* @author  Adam van Dongen
* @version $Id$
* 
* --------------------------------------------------------------------------------
* All rights reserved. Easy Guestbook Component for Joomla!
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the Joomla-addons Free Software License 
* See LICENSE.php for more information.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
* --------------------------------------------------------------------------------
**/

function com_install(){
  $option = 'com_easygb'; //option will contain the correct name
  
  if(defined('JPATH_BASE')){ //joomla 1.5, default
    $is15 = true;
    $database = & JFactory::getDBO();
    $path = str_replace(DS . 'administrator', '', JPATH_BASE);
  } else {
    $is15 = false;
    global $mainframe, $database;
    $path = $mainframe->getCfg('absolute_path');
  }
  
  define('BASE_PATH', $path);
  if(!defined('DS')){
    define('DS', DIRECTORY_SEPARATOR);
  }
  
  if(file_exists(BASE_PATH . DS . 'plugins')){
    define('PLUGIN_PATH', 'plugins' . DS . 'system');
  } else {
    define('PLUGIN_PATH', 'mambots' . DS . 'system');
  }
  
  # include unzip files
  require_once( BASE_PATH . DS . 'administrator' . DS . 'includes' . DS . 'pcl' . DS . 'pclzip.lib.php' );
	require_once( BASE_PATH . DS . 'administrator' . DS . 'includes' . DS . 'pcl' . DS . 'pclerror.lib.php' );
	if((substr(PHP_OS, 0, 3) == 'WIN')) {
		define('OS_WINDOWS',1);
	} else {
		define('OS_WINDOWS',0);
	}
  
  # unzip and install jalib framework
  if(!file_exists(BASE_PATH . DS . PLUGIN_PATH . DS . 'jalib')){
    # check if system directory exists in mambots, mambo does not have this for example
    if(!file_exists(BASE_PATH . DS . PLUGIN_PATH)){
      if(!mkdir(BASE_PATH . DS . PLUGIN_PATH)){
        echo '<font color="red">Installation error</font><br /><br />';
        echo 'Failed to create directory: ' . PLUGIN_PATH . '.<br />';
        echo 'No changes have been made to your system yet, you can simply un-install and try again';
        return false;
      }
    }
    
    # check if plugin directory writable
    if(!is_writable(BASE_PATH . DS . PLUGIN_PATH)){
      echo '<font color="red">Installation error</font><br /><br />';
      echo 'Make sure the plugin path: ' . PLUGIN_PATH . ' is writable.<br />';
      echo 'No changes have been made to your system yet, you can simply un-install and try again once the directory is writable';
      return false;
    }
    # create jalib directory
    if(!mkdir(BASE_PATH . DS . PLUGIN_PATH  . DS . 'jalib')){
      echo '<font color="red">Installation error</font><br /><br />';
      echo 'Failed to create directory: ' . PLUGIN_PATH . DS . 'jalib.<br />';
      echo 'No changes have been made to your system yet, you can simply un-install and try again';
      return false;
    }
    # unzip jalib.ja file
    $zipfile = new PclZip( BASE_PATH . DS . 'components' . DS . $option . DS . 'jalib.ja');
    $ret = $zipfile->extract( PCLZIP_OPT_PATH, BASE_PATH . DS . PLUGIN_PATH . DS . 'jalib' );
		if($ret == 0) {
		  echo '<font color="red">Installation error</font><br /><br />';
		  echo 'Failed to extract jalib zip file: ' . $zipfile->errorName(true) . '.<br />';
			return false;
		}
		# remove jalib.ja file
		if(!unlink(BASE_PATH . DS . 'components' . DS . $option . DS . 'jalib.ja')){
		  echo '<font color="orange">Installation warning</font><br /><br />';
		  echo 'Failed to remove jalib zip file: ' . 'components' . DS . $option . DS . 'jalib.ja' . '.<br />';
		  echo 'Make sure you remove the file manually.<br />';
		}
  } else {
    echo '- jalib already exists, skipping installation<br />';
  }
  # unzip $option files
  if(!is_writable(BASE_PATH . DS . 'components' . DS . $option)){
    echo '<font color="red">Installation error</font><br /><br />';
    echo 'Make sure the component path: ' . 'components' . DS . $option . ' is writable.<br />';
    echo 'No changes have been made to your system yet, you can simply un-install and try again';
    return false;
  }
  
  $zipfile = new PclZip( BASE_PATH . DS . 'components' . DS . $option . DS . $option . '.ja');
  $ret = $zipfile->extract( PCLZIP_OPT_PATH, BASE_PATH . DS . 'components' . DS . $option );
	if($ret == 0) {
	  echo '<font color="red">Installation error</font><br /><br />';
	  echo 'Failed to extract ' . $option . ' zip file: ' . $zipfile->errorName(true) . '.<br />';
		return false;
	}
	# remove jalib.ja file
	if(!unlink(BASE_PATH . DS . 'components' . DS . $option . DS . $option . '.ja')){
	  echo '<font color="orange">Installation warning</font><br /><br />';
	  echo 'Failed to remove ' . $option . ' zip file: ' . 'components' . DS . $option . DS . $option . '.ja' . '.<br />';
	  echo 'Make sure you remove the file manually.<br />';
	}
	
	# execute framework install queries
  if(!file_exists(BASE_PATH . DS . PLUGIN_PATH  . DS . 'jalib' . DS . 'install.sql')){
    echo '<font color="red">Installation error</font><br /><br />';
    echo 'No framework install.sql file was found.<br />';
    return false;
  }
  
  $queries = file_get_contents(BASE_PATH . DS . PLUGIN_PATH  . DS . 'jalib' . DS . 'install.sql');
  $queries = explode(';', $queries);
  
  for($i=0,$n=count($queries);$i<$n;$i++){
    $query = trim($queries[$i]);
    
    if(!empty($query)){
      $database->setQuery($query);
      if(!$database->query()){
        echo '<font color="red">Installation error</font><br /><br />';
        echo 'Query error: ' . $database->getErrorMsg() . '.<br />';
        return false;
      }
    }
  }
  
  # execute component install queries
  if(!file_exists(BASE_PATH . DS . 'components' . DS . $option . DS . 'install.sql')){
    echo '<font color="red">Installation error</font><br /><br />';
    echo 'No component install.sql file was found.<br />';
    return false;
  }
  
  $queries = file_get_contents(BASE_PATH . DS . 'components' . DS . $option . DS . 'install.sql');
  $queries = explode(';', $queries);
  
  for($i=0,$n=count($queries);$i<$n;$i++){
    $query = trim($queries[$i]);
    
    if(!empty($query)){
      $database->setQuery($query);
      if(!$database->query()){
        echo '<font color="red">Installation error</font><br /><br />';
        echo 'Query error: ' . $database->getErrorMsg() . '.<br />';
        return false;
      }
    }
  }
  
  # remove query file
  if(!unlink(BASE_PATH . DS . 'components' . DS . $option . DS . 'install.sql')){
	  echo '<font color="orange">Installation warning</font><br /><br />';
	  echo 'Failed to remove install.sql file: ' . 'components' . DS . $option . DS . 'install.sql' . '.<br />';
	  echo 'Make sure you remove the file manually.<br />';
	}
}


?>